let zero_big_int = Z.zero
let unit_big_int = Z.one
let two_big_int = Z.of_int 2
let three_big_int = Z.of_int 3
let p = Z.of_string "115792089237316195423570985008687907853269984665640564039457584007908834671663"

let argc = Array.length Sys.argv;;
if argc < 3 then (Printf.printf "expected <numiters> [add|mul|mul2|mul3|square] <filename>\n"; exit 1);;
let n = if argc > 3 then (try int_of_string (Sys.argv.(argc-3)) with _ -> 1) else 1;;
let op = Sys.argv.(argc-2);;
let fn = Sys.argv.(argc-1);;
if not (Sys.file_exists fn) then (Printf.printf "expected <numiters> [add|mul|mul2|mul3|square] <filename>\n"; exit 1);;
for i = 1 to n do
if op = "add" then
  begin
    let f = open_in fn in
    try
      let cnt = ref 1 in
      while true do
        let l = input_line f in
        let x = Z.of_string l in
        let l = input_line f in
        let y = Z.of_string l in
        let l = input_line f in
        let z = Z.of_string l in
        let r = Z.rem (Z.add x y) p in
        if not (Z.equal r z) then (Printf.printf "Example %d failed.\n" !cnt; raise Exit);
        incr cnt
      done
    with _ -> close_in f
  end
else if op = "mul" then
  begin
    let f = open_in fn in
    try
      let cnt = ref 1 in
      while true do
        let l = input_line f in
        let x = Z.of_string l in
        let l = input_line f in
        let y = Z.of_string l in
        let l = input_line f in
        let z = Z.of_string l in
        let r = Z.rem (Z.mul x y) p in
        if not (Z.equal r z) then (Printf.printf "Example %d failed.\n" !cnt; raise Exit);
        incr cnt
      done
    with _ -> close_in f
  end
else if op = "mul2" then
  begin
    let f = open_in fn in
    try
      let cnt = ref 1 in
      while true do
        let l = input_line f in
        let x = Z.of_string l in
        let l = input_line f in
        let z = Z.of_string l in
        let r = Z.rem (Z.mul two_big_int x) p in
        if not (Z.equal r z) then (Printf.printf "Example %d failed.\n" !cnt; raise Exit);
        incr cnt
      done
    with _ -> close_in f
  end
else if op = "mul3" then
  begin
    let f = open_in fn in
    try
      let cnt = ref 1 in
      while true do
        let l = input_line f in
        let x = Z.of_string l in
        let l = input_line f in
        let z = Z.of_string l in
        let r = Z.rem (Z.mul three_big_int x) p in
        if not (Z.equal r z) then (Printf.printf "Example %d failed.\n" !cnt; raise Exit);
        incr cnt
      done
    with _ -> close_in f
  end
else if op = "square" then
  begin
    let f = open_in fn in
    try
      let cnt = ref 1 in
      while true do
        let l = input_line f in
        let x = Z.of_string l in
        let l = input_line f in
        let z = Z.of_string l in
        let r = Z.rem (Z.mul x x) p in
        if not (Z.equal r z) then (Printf.printf "Example %d failed.\n" !cnt; raise Exit);
        incr cnt
      done
    with _ -> close_in f
  end
else
  (Printf.printf "expected <numiters> [add|mul|mul2|mul3|square] <filename>\n"; exit 1)
done;;
